package com.bureau.devicefingerprint.datacollectors

import android.annotation.SuppressLint
import android.content.ContentResolver
import android.provider.Settings
import com.bureau.devicefingerprint.di.DeviceFingerprintScope
import com.bureau.devicefingerprint.tools.executeSafe
import javax.inject.Inject

@DeviceFingerprintScope
class AndroidIdProvider @Inject constructor(
    private val contentResolver: ContentResolver
) {
    @SuppressLint("HardwareIds")
    fun getAndroidId(): String {
        return executeSafe({
            Settings.Secure.getString(
                contentResolver,
                Settings.Secure.ANDROID_ID
            )
        }, "")
    }
}
