package com.bureau.devicefingerprint.usecases

import com.bureau.devicefingerprint.di.DeviceFingerprintScope
import com.bureau.devicefingerprint.models.EncryptedDeviceData
import com.bureau.devicefingerprint.models.devicedataholder.DeviceDataHolder
import javax.inject.Inject

@DeviceFingerprintScope
class GetEncryptedDeviceDataUseCase @Inject constructor(private val deviceDataEncryptionUseCase: DeviceDataEncryptionUseCase) {
    operator fun invoke(deviceDataHolder: DeviceDataHolder?): EncryptedDeviceData {
        deviceDataEncryptionUseCase.initKeys()

        return EncryptedDeviceData(
            payload = deviceDataEncryptionUseCase.getEncryptedPayload(deviceDataHolder),
            eaKey = deviceDataEncryptionUseCase.getRSAEncryptedString(deviceDataEncryptionUseCase.passPhrase),
            eaIV = deviceDataEncryptionUseCase.getRSAEncryptedString(deviceDataEncryptionUseCase.ivGlobal)
        )
    }
}
